summaryrefslogtreecommitdiffstats
path: root/system/wine/wine.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'system/wine/wine.SlackBuild')
-rw-r--r--system/wine/wine.SlackBuild70
1 files changed, 54 insertions, 16 deletions
diff --git a/system/wine/wine.SlackBuild b/system/wine/wine.SlackBuild
index 12a0939ec6..7cc898ef39 100644
--- a/system/wine/wine.SlackBuild
+++ b/system/wine/wine.SlackBuild
@@ -28,7 +28,8 @@ cd $(dirname $0) ; CWD=$(pwd)
PRGNAM=wine
VERSION=${VERSION:-9.0}
-BUILD=${BUILD:-1}
+ARCHS="i386,x86_64"
+BUILD=${BUILD:-3}
TAG=${TAG:-_SBo}
PKGTYPE=${PKGTYPE:-tgz}
@@ -56,19 +57,6 @@ else
do_opengl="without"
fi
-WINE32=${WINE32@L}
-WINE64=${WINE64@L}
-WINETMP="$( mktemp -d $TMP/wine-test-XXXXXX )"
-echo "int main(void) {; return(0); }" > "$WINETMP/test.c"
-gcc -m32 "$WINETMP/test.c" -o /dev/null >/dev/null 2>&1 && WINE32=${WINE32:-yes}
-gcc -m64 "$WINETMP/test.c" -o /dev/null >/dev/null 2>&1 && WINE64=${WINE64:-yes}
-rm -rf "$WINETMP"
-
-if [ "$WINE32$WINE64" = "nono" ]; then
- echo "Both 64 and 32 bit builds disabled. Nothing to do."
- exit 1
-fi
-
BUILD_ARCH="$ARCH-slackware-linux"
SLKCFLAGS="-O2"
@@ -82,13 +70,35 @@ case "$ARCH" in
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=78911
# https://bugs.gentoo.org/613128
SLKCFLAGS="-Os -march=$ARCH -mtune=i686"
+ WINE32="yes"
;;
x86_64)
SLKCFLAGS="-O2 -fPIC"
LIBDIRSUFFIX="64"
+ WINE64="yes"
;;
esac
+MULTILIB=${MULTILIB@L}
+if [[ "$ARCH" != "x86_64" && "$MULTILIB" = "yes" ]]; then
+ echo "Cannot build for multilib on non-64bit systems."
+ exit 1
+elif [[ "$ARCH" = "x86_64" && "$MULTILIB" = "yes" ]]; then
+ WINETMP="$( mktemp -d $TMP/wine-test-XXXXXX )"
+ echo "int main(void) {; return(0); }" > "$WINETMP/test.c"
+ gcc -m32 "$WINETMP/test.c" -o /dev/null >/dev/null 2>&1 && WINE32TEST=${WINE32TEST:-yes}
+ rm -rf "$WINETMP"
+ if [[ $WINE32TEST = "yes" ]]; then
+ ARCHS="x86_64"
+ WINE32="yes"
+ else
+ echo "MULTILIB was requested, however the multilib test has failed."
+ echo "Have the compat32 libraries been installed?"
+ echo "Please see README.MULTILIB"
+ exit 1
+ fi
+fi
+
set -e
rm -rf $PKG
@@ -105,7 +115,11 @@ find -L . \
-o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
# Fix for flex
-patch -p1 --verbose < $CWD/0001-winhlp32-Workaround-a-bug-in-Flex.patch
+patch -p1 --verbose < $CWD/flex.patch
+# WriteCopy Fix
+patch -p1 < $CWD/writecopy.patch
+# Fix path of opencl headers.
+sed 's|OpenCL/opencl.h|CL/opencl.h|g' -i configure*
if [ "$WINE64" = "yes" ]; then
wine64="--with-wine64=../wine64"
@@ -122,6 +136,7 @@ if [ "$WINE64" = "yes" ]; then
--sysconfdir=/etc \
--mandir=/usr/man \
--enable-win64 \
+ --enable-archs=$ARCHS \
--with-x \
--with-gnutls \
--${do_opengl}-opengl \
@@ -169,8 +184,31 @@ find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | gr
find $PKG/usr/man -type f -exec gzip -9 {} \;
for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+# Add font configuration:
+install -d $PKG/etc/fonts/conf.{avail,d}
+install -m644 $CWD/30-win32-aliases.conf $PKG/etc/fonts/conf.avail
+ln -sf /etc/fonts/conf.avail/30-win32-aliases.conf $PKG/etc/fonts/conf.d/30-win32-aliases.conf
+install -Dm 644 $CWD/wine-binfmt.conf $PKG/usr/lib$LIBDIRSUFFIX/binfmt.d/wine.conf
+
+# Create Wine menu structure:
+mkdir -p $PKG/etc/xdg/menus/applications-merged
+cp $CWD/wine.menu $PKG/etc/xdg/menus/applications-merged
+
+# Add a desktop menu for winecfg, wine-uninstaller and wine-browsedrive:
+mkdir -p $PKG/usr/share/{applications,icons/hicolor/scalable/apps,pixmaps}
+
+convert $CWD/wine.svg -scale 64 $PKG/usr/share/pixmaps/wine.png
+cp $CWD/wine.svg $PKG/usr/share/icons/hicolor/scalable/apps/
+
+convert $CWD/winecfg.png -scale 64 $PKG/usr/share/pixmaps/winecfg.png
+convert $CWD/winecfg.png -scale 64 $PKG/usr/share/pixmaps/folder-wine.png
+convert $CWD/winecfg.png -scale 64 $PKG/usr/share/pixmaps/wine-uninstaller.png
+
+cp programs/winecfg/winecfg.svg $PKG/usr/share/icons/hicolor/scalable/apps/
+cp $CWD/*.desktop $PKG/usr/share/applications/
+
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
-cp -a ANNOUNCE.md AUTHORS COPYING.LIB LICENSE* README.md VERSION \
+cp -a ANNOUNCE.md AUTHORS COPYING.* LICENSE* README.md VERSION \
$PKG/usr/doc/$PRGNAM-$VERSION
cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild